function alarmResult=challenge(recordName,alarm_type)

    arr_string = alarm_type;
    
    [~,~,~,Fs,info] = rdmat(recordName);
    matfile = ([recordName,'.mat']);
    load(matfile)
    
    info_sq = squeeze(struct2cell(info));
    gain = cell2mat(info_sq(3,:));
    type = info_sq(4,:);
    
    ecg_id = 0;
    ppg_id = 0;
    abp_id = 0;
    resp_id = 0;

    for i=1:1:length(type)

        ecg_id1 = 1;
        gain_ecg1 = gain(1);
        
        ecg_id2 = 2;
        gain_ecg2 = gain(2);
        
        if(strcmp(type(i),'PLETH'))
            ppg_id = i;
            gain_ppg = gain(i);
        end
        if(strcmp(type(i),'ABP'))
            abp_id = i;
            gain_abp = gain(i)*40;
        end
%         if(strcmp(type(i),'RESP'))
%             resp_id = i;
%             gain_resp = gain(i);
%         end    
    end

    
    if((ecg_id1))
        raw_data = val(ecg_id1,:);
        ecg_data1 = raw_data/gain_ecg1;
        ecg_data = ecg_data1;
    end
    
    if((ecg_id2))
        raw_data = val(ecg_id2,:);
        ecg_data2 = raw_data/gain_ecg2;
    end
    
    
    if((abp_id))
        raw_data = val(abp_id,:);
        ppg_data = raw_data/gain_abp;
    end
    if((ppg_id))
        raw_data = val(ppg_id,:);
        ppg_data = raw_data/gain_ppg;
    end

   if((~isempty(ecg_data))  && (~isempty(ppg_data)))
       
       if(strcmp(arr_string,'Asystole'))
           [alarmResult] = predictAsys(ecg_data1,ecg_data2,ppg_data,Fs);
           
       elseif(strcmp(arr_string,'Ventricular_Flutter_Fib'))
           [alarmResult] = predictVfib(ecg_data1,ecg_data2,Fs);
       
       elseif(strcmp(arr_string,'Ventricular_Tachycardia'))
           [alarmResult] = predictVtch(ecg_data1,ecg_data2,Fs);
       
       elseif(strcmp(arr_string,'Tachycardia'))
           [alarmResult] = predictTcardia(ecg_data1,ecg_data2,Fs);
           
       elseif(strcmp(arr_string,'Bradycardia'))
           [alarmResult] = predictBcardia(ecg_data1,ecg_data2,ppg_data,Fs);
       end
        
    else
        alarmResult = 0;
    end
    
    answers = 'answers.txt';
    
    % Write result to answers.txt
    fid = fopen(answers, 'a');
    if (fid == -1)
        error('Could not open answer file');
    end

    % Get base name of record (without directories)
    i = strfind(recordName, filesep);
    if (~isempty(i))
        basename = recordName(i(end)+1 : end);
    else
        basename = recordName;
    end

    fprintf(fid, '%s,%d\n', basename, alarmResult);
    fclose(fid);