function result = check_flatline(signal,Fs,arr,sig_type,full_check)

if(nargin < 5)
    full_check = 0;
end

if(nargin < 4)
    sig_type = 1;
end

if(full_check)
    thresh = 0.5*length(signal);
else
    thresh = Fs;
end

result = 0;

diffpts = diff(find(diff(signal)==0));
seqpts = find([diffpts inf]> 1);
seqlen = diff([0 seqpts]) + 1;
flatline = find(seqlen > thresh);
flatline_s = find(seqlen > 0.25*thresh);
if(~isempty(flatline))
    result = 1;
elseif(~isempty(flatline_s))
    if(length(flatline_s)>=4)
        result = 1;
    end
end

for i=1:1:length(signal)-Fs
    
    block = signal(i:i+Fs);
    if(var(block) < 0.000001)
        result = 1;
        break;
    end
end
     
signpts = sign(diff(signal));
diffpts = abs(diff(signpts));
zeropts = diff(diffpts);

diffpts = diff(find(diff(zeropts)==0));
seqpts = find([diffpts inf]> 1);
seqlen = diff([0 seqpts]);
flatline = find(seqlen > thresh);

if(~isempty(flatline))
    result = 1;
end

if(sig_type == 1 && (arr==3 || arr==4))
    signal = signal-mean(signal);
    [~,high_sig] = findpeaks(signal,'MINPEAKHEIGHT',2.5,'MINPEAKDISTANCE',round(0.01*Fs));
    w = warning('query','last');
    if(~isempty(w))
        id = w.identifier;
        warning('off',id);
    end
    high_sig1 = find((signal > 6.0) | (signal < -6.0));
    
    if(~isempty(high_sig))
        high_len = high_sig(end) - high_sig(1);
        if((length(high_sig)>=5) && (high_len <= 1*Fs))
            result = 1;
        end
    end
    
    [~,spike_val] = findpeaks(signal,'MINPEAKHEIGHT',(0.77*max(signal)),'MINPEAKDISTANCE',round(0.01*Fs));
    %spike_val = find(signal > (0.77*max(signal)))
    w = warning('query','last');
    if(~isempty(w))
        id = w.identifier;
        warning('off',id);
    end
    if(~isempty(spike_val))
        spike_len = spike_val(end) - spike_val(1);
        if((length(spike_val)>=20) && (spike_len <= 3*Fs))
            result = 1;
        end
    end
    
    if(length(high_sig1) >= 1 && length(high_sig1) <=4)
        result = 1;
    end
    
    %     high_sig = find(signal > 2.5);
%     if(~isempty(high_sig))
%         high_len = high_sig(end) - high_sig(1);
%         if((length(high_sig)>=5) && (high_len <= 1*Fs))
%             result = 1;
%         end
%     end
end


if(sig_type == 2)
    
    if(arr ~= 3) 
    
        max_sig = max(sig_type);
        signal = signal/max_sig;
        signal = signal-mean(signal);

        if(arr == 1)
            ppg_bl = butter_bidir(0.5,signal,Fs,4,'low');
        else
            ppg_bl = butter_bidir(1,signal,Fs,4,'low');
        end
        % 
        % figure, plot(signal);
        % hold on
        % plot(ppg_bl,'m','Linewidth',2)
        % grid on
        % hold off

        var_ratio = var(signal)/var(ppg_bl);
        if(var_ratio < 7)
            result = 1;

        end
        
    end
    
end
