function [result] = predictVtch(ecg_data1,ecg_data2,Fs)

    load 'vtchPredictive_Model.mat'
    
    pred_result = [0 0];
    test_s = 1;

    for loop=1:1:2
        
        if(loop == 1)
            ecg_data = ecg_data1;
        else
            ecg_data = ecg_data2;
        end
        
        rval = [];
        [x_fv,tn,ecg_data1] = get_fv2(ecg_data,Fs);
        
        [num_seg,~] = size(x_fv);
        
        flat = 0;
        
        if(tn==0)
            
            test_set = x_fv;
            
            [m_test,n_test] = size(test_set);
            test_f = m_test;
        else
            flat = 1;
        end
        
        if(~flat)
            test_len = test_f - test_s + 1;
            
            for i=1:1:n_test
                test_set(:,i) = (test_set(:,i) - mean_x(i))/(max_x(i) - min_x(i));
            end
            
            test_x = [ones(test_len,1) test_set];
            
            [svm_y,predict_score] = predict(svm_struct,test_x);
            pos = find(svm_y == 1);
            
            vhconf_val = find(predict_score(pos,1) < -1.1);
            
            rlocs = get_rpeaks(ecg_data1,Fs);
            ecg_block = ecg_data1;
            max_ecgblock = max(ecg_block(rlocs));
            ecg_block_pos = find(ecg_block >= 0);
            ecg_block(ecg_block_pos) = ecg_block(ecg_block_pos)/max_ecgblock;
            
            min_ecgblock = (-1)*min(ecg_block);
            ecg_block_neg = find(ecg_block < 0);
            ecg_block(ecg_block_neg) = ecg_block(ecg_block_neg)/min_ecgblock;
            
            for r=1:1:length(rlocs)
                
                if(ecg_block(rlocs(r)) >= 0.74)
                    rval(r) = 2;
                elseif(ecg_block(rlocs(r)) >= 0)
                    rval(r) = 1;
                elseif(ecg_block(rlocs(r)) >= -0.74)
                    rval(r) = -1;
                else
                    rval(r) = 0;
                end
            end
            
            rval_diff = diff([rval(1) rval]);
            
            rzero_loc = find(rval_diff ~= 0);
            rzero_loc = [rzero_loc length(rval_diff)+1];
            rzero_len = diff([1 rzero_loc]);
            rzero_ind = ones(1,length(rzero_len));
            
            for r = 2:1:length(rzero_ind)
                
                rzero_ind(r) = rzero_len(r-1)+rzero_ind(r-1);
            end
            
            
            for r = 1:1:length(rzero_loc)-1
                
                if((rval(rzero_loc(r)) - rval(rzero_loc(r)-1)) < 0)
                    
                    rzero_len(r+1) = rzero_len(r+1)*(-1);
                end
            end
            if(abs(rval(1)) == 1)
                rzero_len(1) = rzero_len(1) * (-1);
            end
            
            if(~isempty(vhconf_val))
                
                rr1 = zeros(1,num_seg);
                for ll1 =1:1:num_seg
                    
                    if(predict_score(ll1,1) < -0.2)
                        
                        if(ll1 == 1)
                            rr1(ll1) = rr1(ll1) + 1;
                        else
                            rr1(ll1) = rr1(ll1-1) + 1;
                        end
                    end
                end
                
                [a,b] = max(rr1);
                c = b-a+1;
                ll = ceil(c):ceil(b);
                
                vhconf_len= length(find(predict_score(ll,1) < -1.0));
                
                med = floor(median(ll));
                st = ceil(med*.2*Fs);
                fi = ceil(st)+499;
                ecg_temp1 = ecg_data1(st:fi);
                z1 = xcorr(ecg_temp1,'coeff');
                [pks,~] = findpeaks(z1,'MINPEAKDISTANCE',50,'MINPEAKHEIGHT',0);
                
                pks_desc = sort(pks,'descend');
                
                
                if(length(pks)<=2)
                    break;
                end
                
                if((length(vhconf_val)/num_seg) > 0.74)
                    
                    pred_result(1,loop) = 1;
                    break;
                end
                if((pks_desc(2) > 0.4) || (vhconf_len >= 10))
                    
                    for r=1:1:length(rzero_len)
                        
                        if((rzero_len(r) <=-4 && (rzero_len(r)~=length(rval))) || (rzero_len(r) >= 4))
                            
                            for s=1:1:abs(rzero_len(r)) - 3;
                                
                                st_s = abs(rzero_ind(r))+s-1;
                                fi_s = st_s + 3;
                                
                                rblock = (rlocs(fi_s) - rlocs(st_s))/3;
                                rblock_bpm = (Fs/rblock)*60;
                                
                                if(rblock_bpm >=97)
                                    pred_result(1,loop) = 1;
                                    break;
                                end
                            end
                        end
                        if(pred_result(1,loop) == 1)
                            break;
                        end
                    end
                    if(pred_result(1,loop) == 1)
                        break;
                    end
                end
            end
        end
    end
    
    result = pred_result(1,1) || pred_result(1,2);
end